#ifndef FINDGEODESIC_H
#define FINDGEODESIC_H

#include "MeshDefinition.h"
#include <queue>

class Findgeodesic
{
public:
	Findgeodesic();
	Findgeodesic(const Mesh & mesh_);
	void set_mesh(Mesh & mesh_);
	void set_edges_weight(std::vector<std::vector<double>> & edges_wei);
	~Findgeodesic();

	void Find_Geodesic(int sou_p, std::vector<int>& is_target, int size_);
	std::vector<int> Find_Geodesic(int sou_p, std::vector<int>& is_target);
	std::vector<int> Find_Geodesic(int sou_p, int tar_p);    //õ·
	void Dijkstra(int sou_v, int tar_v);                     //Dijkstra㷨
	void Dijkstra(int sou_v, std::vector<int>& is_target, int size_);
	int Dijkstra(int sou_v, std::vector<int> is_target);
	std::vector<int> searchPath(int sou_v, int tar_v);       //õ㵽յ·
	std::vector<int> Change_Geodesic(int sou_p, int tar_p, std::vector<int> visit_or_not);  //ڷ·غϣѰ·
	void Change_Dijkstra(int sou_v, int tar_v, std::vector<int> visit_or_not);              //ӦChange_Geodesic

	double distance_weight;                                  //㵽յ̾룬ΪСȨ
	std::vector<double>              dist;           //i㵽ʼľ

private:
	Mesh my_mesh;
	int  nv;                                         //
	std::vector<std::vector<int>>    one_ring;       //жһ
	std::vector<std::vector<double>> one_ring_length;//жһ㵽ĵľ
	
	std::vector<int>                 prev;           //i֮ǰе

	const double maxint = 1e40;
	std::vector<std::vector<std::pair<int, double>>> G;
};


#endif // FINDGEODESIC_H